import { Providers } from "./providers";
interface IdempotencyHttpOptionsProviderDynamoDB {
    name: Providers.DynamoDB;
    endpoint?: string;
    region: string;
    tableName: string;
}
interface IdempotencyHttpOptionsRequestId {
    from: "requestId";
}
interface IdempotencyHttpOptionsHeader {
    from: "header";
    name: string;
    fallback?: boolean;
}
declare type IdempotencyHttpOptionsId = IdempotencyHttpOptionsRequestId | IdempotencyHttpOptionsHeader;
export interface IdempotencyHttpOptions {
    handler: CallableFunction;
    provider: IdempotencyHttpOptionsProviderDynamoDB;
    ttl?: number;
    id: IdempotencyHttpOptionsId;
}
export declare const idempotencyHttpWrapper: (options: IdempotencyHttpOptions) => CallableFunction;
export {};
