"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamoDB = void 0;
var aws_sdk_1 = __importDefault(require("aws-sdk"));
var DynamoDB = /** @class */ (function () {
    function DynamoDB(options) {
        this.ddb = new aws_sdk_1.default.DynamoDB.DocumentClient({
            endpoint: options.endpoint,
            region: options.region,
        });
        this.tableName = options.tableName;
        this.ttl = options.ttl;
    }
    DynamoDB.prototype.fetch = function (messageId) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.ddb
                            .get({
                            Key: { messageId: messageId },
                            TableName: this.tableName,
                        })
                            .promise()];
                    case 1:
                        result = _b.sent();
                        return [2 /*return*/, (_a = result.Item) === null || _a === void 0 ? void 0 : _a.result];
                }
            });
        });
    };
    DynamoDB.prototype.isProcessing = function (messageId) {
        return __awaiter(this, void 0, void 0, function () {
            var creationTime, ttl, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        creationTime = Math.floor(Date.now() / 1000);
                        ttl = creationTime + this.ttl;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.ddb
                                .put({
                                ConditionExpression: "attribute_not_exists(messageId)",
                                Item: { messageId: messageId, ttl: ttl },
                                TableName: this.tableName,
                            })
                                .promise()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, false];
                    case 3:
                        error_1 = _a.sent();
                        if (error_1.name === "ConditionalCheckFailedException") {
                            return [2 /*return*/, true];
                        }
                        throw error_1;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    DynamoDB.prototype.update = function (messageId, result) {
        return __awaiter(this, void 0, void 0, function () {
            var creationTime, ttl;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        creationTime = Math.floor(Date.now() / 1000);
                        ttl = creationTime + this.ttl;
                        return [4 /*yield*/, this.ddb
                                .put({
                                Item: { messageId: messageId, result: result, ttl: ttl },
                                TableName: this.tableName,
                            })
                                .promise()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return DynamoDB;
}());
exports.DynamoDB = DynamoDB;
